{{

File  :  RGB_LED_Matrix_Pumpkin7

Adapted from Original source:
  File  :  RGB_LED_Matrix_Demo.spin
  Author:  John Zhong
  Company: SimplyTronics
  Version: 1.0
  Date   : 2012-11-09

09/04/2016 - Francis Bauer
  Modified for 3x3 module matrix display of a 24x24 pixel pumpkin.     

}}

CON             
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

_pinTx   = 0                                       'RGB Serial Transmit Pin.
_pinRx   = 1                                       'RGB Serial Receive  Pin.

NumXrows = 24                                      'Number of X rows    of image.
NumYcols = 24                                      'Number of Y columns of image.

debug    = 0                                       'Serial Term debug mode 1 = on, 0 = off.
  
                  
OBJ
                                    
  RGB    : "RGB_LED_Matrix_Driver_Simple3.spin"
  pst    : "Parallax Serial Terminal" 

PUB main | WaitTime

    if debug
      pst.Start(115_200)   

    RGB.Start(_pinRx,_pinTx, 19200)
    wait(2000)                                     'Pause to wait for the RGB Module start.            

    RGB.ChangeBaudrate(115200)                     'Increase baudrate.

    RGB.ClearScreen($0000_0000)                    'Send Clear Screen command. (AABB_GGRR)
    RGB.UpdateScreen                               'Update Screen for current command.

    DisplayFB                                      'Display FB
    DisplayText(string("09/30/2016"),0,11,$FF_00_00) 'Display Text (scrolling).

    RGB.ClearScreen($0000_0000)                    'Send Clear Screen command. (AABB_GGRR)
    RGB.UpdateScreen                               'Update Screen for current command. 
    DrawFrame(@Pumpkin)
    RGB.UpdateScreen                               'Update Screen with current image/data.
    RGB.CopyGDRAM2(0)                              'Store current image for retrieval later.
    WaitTime := 100
    wait(10 * WaitTime)
repeat
    repeat 5
      DrawFrame(@Leyell)
      DrawFrame(@Reyell)
      DrawFrame(@NoseHole)
      DrawFrame(@MouthOpen)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
      DrawFrame(@Leyelm)
      DrawFrame(@Reyelm)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
      DrawFrame(@Leyelm1)
      DrawFrame(@Reyelm1)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
      DrawFrame(@Leyelr)
      DrawFrame(@Reyelr)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
      DrawFrame(@Leyelm1)
      DrawFrame(@Reyelm1)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
      DrawFrame(@Leyelm)
      DrawFrame(@Reyelm)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
    DrawFrame(@Leyell)
    DrawFrame(@Reyelm1)
    RGB.UpdateScreen                               'Update Screen with current image/data.
    wait(WaitTime)  
    repeat 5
      DrawFrame(@Leyell)
      DrawFrame(@Reyelr)
      DrawFrame(@NoseFill)
      DrawFrame(@Mouth1)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
      DrawFrame(@Leyelm)
      DrawFrame(@Reyelm1)
      DrawFrame(@NoseFill1)
      DrawFrame(@Mouth2)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
      DrawFrame(@Leyelm1)
      DrawFrame(@Reyelm)
      DrawFrame(@NoseFill2)
      DrawFrame(@Mouth3)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
      DrawFrame(@Leyelr)
      DrawFrame(@Reyell)
      DrawFrame(@NoseFill3)
      DrawFrame(@MouthClse)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
      DrawFrame(@Leyelm1)
      DrawFrame(@Reyelm)
      DrawFrame(@NoseFill2)
      DrawFrame(@Mouth3)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
      DrawFrame(@Leyelm)
      DrawFrame(@Reyelm1)
      DrawFrame(@NoseFill1)
      DrawFrame(@Mouth2)
      RGB.UpdateScreen                             'Update Screen with current image/data.
      wait(WaitTime)
    DrawFrame(@MouthOpen)
    DisplayText(string("   HAPPY HALLOWEEN"),0,15,$00_00_FF) 'Display Text (scrolling).
    RGB.DisplayGDRAM(0)                            'Re-display previously stored image.


PRI DisplayFB
{{ ********** Display "F" "B" ********** }}
  
    RGB.SetMode(RGB#_ModeNormal)
    '                          Foreground Color
    '                           B  G  R
    RGB.ASCII_0508NBG("F",0, 0,$FF_00_00 )
    RGB.SetMode(RGB#_ModeOverlay)
    '                          Foreground Color
    '                           B  G  R
    RGB.ASCII_0508NBG("B",3, 3,$00_00_FF  )
    RGB.UpdateScreen 
    RGB.SetMode(RGB#_ModeNormal) 

    
PRI DisplayText(DispText,TextXmin,TextY,TextColor) | prev_Xpos, Xpos
{/*******************************************************
              Display Text String 0508
*******************************************************/}
       prev_Xpos := 0   
       repeat Xpos from TextXmin to (-8 * strsize(DispText))    'Loop to potentially scroll text along X axis.
          String_0508NBG(DispText, prev_Xpos, TextY, $00000000) 'Blank previous text/string.   
          String_0508NBG(DispText, Xpos, TextY, TextColor)      'Write new text/string.
          RGB.updateScreen                         
          wait(75)
          prev_Xpos := Xpos

      
PRI String_0508NBG(stringPtr,StartX,StartY,ForegroundColor) | index    
{/*******************************************************
         Function: display the 0508 ASCII string
*******************************************************/}
     index := 0
     RGB.TxDatPackHead(RGB#_SetForegroundColor, ForegroundColor)
     RGB.TxDatPackHead(RGB#_SetPointerY, StartY)
      
     repeat strsize(stringPtr)
          RGB.TxDatPackHead(RGB#_SetPointerX, StartX + (index * 8))       
          RGB.TxDatPackHead(RGB#_DisplayChar0508NBG, byte[stringPtr + index])
          index++

          
PRI DrawFrame(Frame) | Xmin, Xmax, Xrow, Ycol, Color, Index
{{ ********** Display image ********** }}
    
    Index := 0                                     'Reset Index pointer.
    Ycol := byte[Frame][Index]                     'Obtain Ycol value.
    repeat while Ycol < NumYcols                   'Loop until End-of-dataset.
      Xmin := byte[Frame][++Index]
      Xmax := byte[Frame][++Index]
      Color.byte[3] := 0                           'Clear 1st byte in long. (High)
      Color.byte[2] := byte[Frame][++Index]        'Get Blue  channel value.
      Color.byte[1] := byte[Frame][++Index]        'Get Green channel value.
      Color.byte[0] := byte[Frame][++Index]        'Get Red   channel value. (Low)       
      repeat Xrow from Xmin to Xmax
        if debug
          pst.Str(string("Xrow: "))
          pst.Dec(Xrow)
          pst.Str(string(" Ycol: "))
          pst.Dec(Ycol)
          pst.Str(string(" Color: "))
          pst.Hex(Color,8)
          pst.Chars(pst#NL, 1)
        RGB.Dot(Xrow, Ycol, Color)                 'Send pixel color data to X,Y display position.
      Ycol := byte[Frame][++Index]                 'Obtain next Ycol value.
      if debug
        pst.Str(string("Next Ycol: "))
        pst.Dec(Ycol)
        pst.Chars(pst#NL, 1)    


PUB wait(Time_in_ms)                               'This routine has the program wait the specified number of milliseconds.
  waitcnt(((clkfreq / 1_000 * Time_in_ms - 3932) #> 381) + cnt)
  {{ This will delay/wait the specified number of milliseconds. This is SPIN code, and SPIN is interpreted,
     so it takes significantly longer to interpret and execute the waitcnt command than it does with PASM.
     The 3932 is to compensate for the time that it takes the interpreter to process the computation portion of the command.
     The #>381 insures that you never do a waitcnt with a value less than 381 more than the current CNT, because if you do
     that the counter will have already counted past your target value before the timing starts, and that means you will
     hang there while the counter loops through it's entire 32-bit range, somewhere around a minute (53 seconds).
     Waitcnt waits for the system counter to be exactly equal to the target value. }}

     
DAT

'In order to save memory, I converted the 576 longs that were used to describe the 24x24 BGR pixels of the pumpkin
'image into the following data structure.  Rows/Cols not specified will be left to their previous color settings.

'The image has been rotated 90 deg to display in the correct orientation with the ASCII Text screens.  So Col is actually
'specifying the vertical position and Row is specifying the horizontal position.  Confusing I know, but that is what
'was needed. 

Pumpkin  'Col,  RowStart, RowStop, Color(   B,   G,   R )
    byte    0,      7,       10,          $00, $FF, $00    'Green Stem on Pumpkin.
    byte    1,      7,       11,          $00, $FF, $00    
    byte    2,      7,       12,          $00, $FF, $00    
    byte    3,     10,       13,          $00, $FF, $00    
    byte    4,      5,       18,          $01, $27, $B9    'Orange Flesh of Pumpkin
    byte    5,      3,       20,          $01, $27, $B9
    byte    6,      2,       21,          $01, $27, $B9
    byte    7,      1,       22,          $01, $27, $B9
    byte    8,      1,       22,          $01, $27, $B9
    byte    9,      0,       23,          $01, $27, $B9
    byte   10,      0,       23,          $01, $27, $B9
    byte   11,      0,       23,          $01, $27, $B9
    byte   12,      0,       23,          $01, $27, $B9
    byte   13,      0,       23,          $01, $27, $B9
    byte   14,      0,       23,          $01, $27, $B9
    byte   15,      0,       23,          $01, $27, $B9
    byte   16,      0,       23,          $01, $27, $B9
    byte   17,      0,       23,          $01, $27, $B9
    byte   18,      0,       23,          $01, $27, $B9
    byte   19,      1,       22,          $01, $27, $B9
    byte   20,      1,       22,          $01, $27, $B9
    byte   21,      2,       21,          $01, $27, $B9
    byte   22,      3,       20,          $01, $27, $B9
    byte   23,      5,       18,          $01, $27, $B9    
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

LeyeOpen 'Col,  RowStart, RowStop, Color(   B,   G,   R )
    byte    8,      5,        7,          $00, $00, $00
    byte    9,      4,        8,          $00, $00, $00
    byte   10,      4,        8,          $00, $00, $00
    byte   11,      4,        8,          $00, $00, $00
    byte   12,      5,        7,          $00, $00, $00
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

ReyeOpen 'Col,  RowStart, RowStop, Color(   B,   G,   R )
    byte    8,     16,       18,          $00, $00, $00
    byte    9,     15,       19,          $00, $00, $00
    byte   10,     15,       19,          $00, $00, $00
    byte   11,     15,       19,          $00, $00, $00
    byte   12,     16,       18,          $00, $00, $00
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

LeyeClose'Col,  RowStart, RowStop, Color(   B,   G,   R )
    byte    8,      5,        7,          $00, $FF, $FF
    byte    9,      4,        8,          $00, $FF, $FF
    byte   10,      4,        8,          $00, $FF, $FF
    byte   11,      4,        8,          $00, $FF, $FF
    byte   12,      5,        7,          $00, $FF, $FF
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

ReyeClose'Col,  RowStart, RowStop, Color(   B,   G,   R )
    byte    8,     16,       18,          $00, $FF, $FF
    byte    9,     15,       19,          $00, $FF, $FF
    byte   10,     15,       19,          $00, $FF, $FF
    byte   11,     15,       19,          $00, $FF, $FF
    byte   12,     16,       18,          $00, $FF, $FF
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset
        
Leyell   'Col,  RowStart, RowStop, Color(   B,   G,   R )
    byte    8,      5,        7,          $00, $FF, $FF
    byte    9,      4,        8,          $00, $FF, $FF
    byte   10,      4,        8,          $00, $00, $00
    byte   10,      6,        6,          $00, $00, $00 
    byte   11,      4,        5,          $FF, $00, $00
    byte   11,      6,        8,          $00, $00, $00
    byte   12,      5,        5,          $FF, $00, $00
    byte   12,      6,        7,          $00, $00, $00
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

Reyell   'Col,  RowStart, RowStop, Color(   B,   G,   R )   
    byte    8,     16,       18,          $00, $FF, $FF  
    byte    9,     15,       19,          $00, $FF, $FF   
    byte   10,     15,       19,          $00, $00, $00
    byte   10,     17,       17,          $00, $00, $00 
    byte   11,     15,       16,          $FF, $00, $00
    byte   11,     17,       19,          $00, $00, $00 
    byte   12,     16,       16,          $FF, $00, $00 
    byte   12,     17,       18,          $00, $00, $00
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

Leyelm   'Col,  RowStart, RowStop, Color(   B,   G,   R )
    byte    8,      5,        7,          $00, $FF, $FF  
    byte    9,      4,        8,          $00, $FF, $FF 
    byte   10,      4,        8,          $00, $00, $00
    byte   10,      6,        6,          $00, $00, $00   
    byte   11,      4,        4,          $00, $00, $00
    byte   11,      5,        6,          $FF, $00, $00
    byte   11,      7,        8,          $00, $00, $00   
    byte   12,      5,        6,          $FF, $00, $00
    byte   12,      7,        7,          $00, $00, $00  
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

Reyelm   'Col,  RowStart, RowStop, Color(   B,   G,   R )  
    byte    8,     16,       18,          $00, $FF, $FF 
    byte    9,     15,       19,          $00, $FF, $FF  
    byte   10,     15,       19,          $00, $00, $00
    byte   10,     17,       17,          $00, $00, $00  
    byte   11,     15,       15,          $00, $00, $00
    byte   11,     16,       17,          $FF, $00, $00 
    byte   11,     18,       19,          $00, $00, $00 
    byte   12,     16,       17,          $FF, $00, $00 
    byte   12,     18,       18,          $00, $00, $00
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

Leyelm1  'Col,  RowStart, RowStop, Color(   B,   G,   R )
    byte    8,      5,        7,          $00, $FF, $FF   
    byte    9,      4,        8,          $00, $FF, $FF  
    byte   10,      4,        8,          $00, $00, $00
    byte   10,      6,        6,          $00, $00, $00   
    byte   11,      4,        5,          $00, $00, $00
    byte   11,      6,        7,          $FF, $00, $00
    byte   11,      8,        8,          $00, $00, $00  
    byte   12,      5,        5,          $00, $00, $00
    byte   12,      6,        7,          $FF, $00, $00  
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

Reyelm1  'Col,  RowStart, RowStop, Color(   B,   G,   R )  
    byte    8,     16,       18,          $00, $FF, $FF  
    byte    9,     15,       19,          $00, $FF, $FF 
    byte   10,     15,       19,          $00, $00, $00
    byte   10,     17,       17,          $00, $00, $00  
    byte   11,     15,       16,          $00, $00, $00
    byte   11,     17,       18,          $FF, $00, $00 
    byte   11,     19,       19,          $00, $00, $00  
    byte   12,     16,       16,          $00, $00, $00
    byte   12,     17,       18,          $FF, $00, $00 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

Leyelr   'Col,  RowStart, RowStop, Color(   B,   G,   R )
    byte    8,      5,        7,          $00, $FF, $FF 
    byte    9,      4,        8,          $00, $FF, $FF 
    byte   10,      4,        8,          $00, $00, $00
    byte   10,      6,        6,          $00, $00, $00  
    byte   11,      4,        6,          $00, $00, $00
    byte   11,      7,        8,          $FF, $00, $00  
    byte   12,      5,        6,          $00, $00, $00
    byte   12,      7,        7,          $FF, $00, $00  
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

Reyelr   'Col,  RowStart, RowStop, Color(   B,   G,   R ) 
    byte    8,     16,       18,          $00, $FF, $FF
    byte    9,     15,       19,          $00, $FF, $FF 
    byte   10,     15,       19,          $00, $00, $00
    byte   10,     17,       17,          $00, $00, $00  
    byte   11,     15,       17,          $00, $00, $00
    byte   11,     18,       19,          $FF, $00, $00  
    byte   12,     16,       17,          $00, $00, $00
    byte   12,     18,       18,          $FF, $00, $00 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

MouthOpen'Col,  RowStart, RowStop, Color(   B,   G,   R ) 
    byte   15,     03,       03,          $00, $00, $00
    byte   15,     20,       20,          $00, $00, $00
    byte   16,     03,       03,          $00, $00, $00
    byte   16,     06,       07,          $00, $00, $00 
    byte   16,     11,       11,          $00, $00, $00
    byte   16,     16,       17,          $00, $00, $00
    byte   16,     20,       20,          $00, $00, $00  
    byte   17,     03,       07,          $00, $00, $00
    byte   17,     11,       11,          $00, $00, $00  
    byte   17,     16,       20,          $00, $00, $00
    byte   18,     06,       18,          $00, $00, $00
    byte   19,     06,       06,          $00, $00, $00
    byte   19,     09,       09,          $00, $00, $00
    byte   19,     13,       13,          $00, $00, $00
    byte   19,     17,       17,          $00, $00, $00
    byte   20,     09,       09,          $00, $00, $00
    byte   20,     13,       13,          $00, $00, $00 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

Mouth1   'Col,  RowStart, RowStop, Color(   B,   G,   R ) 
    byte   15,     03,       03,          $FF, $FF, $FF
    byte   15,     20,       20,          $FF, $FF, $FF
    byte   16,     03,       03,          $00, $00, $00
    byte   16,     06,       07,          $00, $00, $00 
    byte   16,     11,       11,          $00, $00, $00
    byte   16,     16,       17,          $00, $00, $00
    byte   16,     20,       20,          $00, $00, $00  
    byte   17,     03,       07,          $00, $00, $00
    byte   17,     11,       11,          $00, $00, $00  
    byte   17,     16,       20,          $00, $00, $00
    byte   18,     06,       18,          $00, $00, $00
    byte   19,     06,       06,          $00, $00, $00
    byte   19,     09,       09,          $00, $00, $00
    byte   19,     13,       13,          $00, $00, $00
    byte   19,     17,       17,          $00, $00, $00
    byte   20,     09,       09,          $FF, $FF, $FF
    byte   20,     13,       13,          $FF, $FF, $FF 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

Mouth2   'Col,  RowStart, RowStop, Color(   B,   G,   R ) 
    byte   15,     03,       03,          $FF, $FF, $FF
    byte   15,     20,       20,          $FF, $FF, $FF
    byte   16,     03,       03,          $FF, $FF, $FF
    byte   16,     06,       07,          $FF, $FF, $FF 
    byte   16,     11,       11,          $FF, $FF, $FF
    byte   16,     16,       17,          $FF, $FF, $FF
    byte   16,     20,       20,          $FF, $FF, $FF  
    byte   17,     03,       07,          $00, $00, $00
    byte   17,     11,       11,          $00, $00, $00  
    byte   17,     16,       20,          $00, $00, $00
    byte   18,     06,       18,          $00, $00, $00
    byte   19,     06,       06,          $FF, $FF, $FF
    byte   19,     09,       09,          $FF, $FF, $FF
    byte   19,     13,       13,          $FF, $FF, $FF
    byte   19,     17,       17,          $FF, $FF, $FF
    byte   20,     09,       09,          $FF, $FF, $FF
    byte   20,     13,       13,          $FF, $FF, $FF 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

Mouth3   'Col,  RowStart, RowStop, Color(   B,   G,   R ) 
    byte   15,     03,       03,          $FF, $FF, $FF
    byte   15,     20,       20,          $FF, $FF, $FF
    byte   16,     03,       03,          $FF, $FF, $FF
    byte   16,     06,       07,          $FF, $FF, $FF 
    byte   16,     11,       11,          $FF, $FF, $FF
    byte   16,     16,       17,          $FF, $FF, $FF
    byte   16,     20,       20,          $FF, $FF, $FF  
    byte   17,     03,       07,          $FF, $FF, $FF
    byte   17,     11,       11,          $FF, $FF, $FF  
    byte   17,     16,       20,          $FF, $FF, $FF
    byte   18,     06,       18,          $00, $00, $00
    byte   19,     06,       06,          $FF, $FF, $FF
    byte   19,     09,       09,          $FF, $FF, $FF
    byte   19,     13,       13,          $FF, $FF, $FF
    byte   19,     17,       17,          $FF, $FF, $FF
    byte   20,     09,       09,          $FF, $FF, $FF
    byte   20,     13,       13,          $FF, $FF, $FF 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

MouthClse'Col,  RowStart, RowStop, Color(   B,   G,   R ) 
    byte   15,     03,       03,          $FF, $FF, $FF
    byte   15,     20,       20,          $FF, $FF, $FF
    byte   16,     03,       03,          $FF, $FF, $FF
    byte   16,     06,       07,          $FF, $FF, $FF 
    byte   16,     11,       11,          $FF, $FF, $FF
    byte   16,     16,       17,          $FF, $FF, $FF
    byte   16,     20,       20,          $FF, $FF, $FF  
    byte   17,     03,       07,          $FF, $FF, $FF
    byte   17,     11,       11,          $FF, $FF, $FF  
    byte   17,     16,       20,          $FF, $FF, $FF
    byte   18,     06,       18,          $FF, $FF, $FF
    byte   19,     06,       06,          $FF, $FF, $FF
    byte   19,     09,       09,          $FF, $FF, $FF
    byte   19,     13,       13,          $FF, $FF, $FF
    byte   19,     17,       17,          $FF, $FF, $FF
    byte   20,     09,       09,          $FF, $FF, $FF
    byte   20,     13,       13,          $FF, $FF, $FF 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

NoseHole 'Col,  RowStart, RowStop, Color(   B,   G,   R ) 
    byte   12,     11,       12,          $00, $00, $00
    byte   13,     10,       13,          $00, $00, $00
    byte   14,     10,       13,          $00, $00, $00 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

NoseFill 'Col,  RowStart, RowStop, Color(   B,   G,   R ) 
    byte   12,     11,       12,          $00, $00, $FF
    byte   13,     10,       13,          $00, $00, $FF
    byte   14,     10,       13,          $00, $00, $FF 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

NoseFill1'Col,  RowStart, RowStop, Color(   B,   G,   R ) 
    byte   12,     11,       12,          $FF, $00, $FF
    byte   13,     10,       13,          $FF, $00, $FF
    byte   14,     10,       13,          $FF, $00, $FF 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

NoseFill2'Col,  RowStart, RowStop, Color(   B,   G,   R ) 
    byte   12,     11,       12,          $00, $FF, $FF
    byte   13,     10,       13,          $00, $FF, $FF
    byte   14,     10,       13,          $00, $FF, $FF 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset

NoseFill3'Col,  RowStart, RowStop, Color(   B,   G,   R ) 
    byte   12,     11,       12,          $FF, $00, $00
    byte   13,     10,       13,          $FF, $00, $00
    byte   14,     10,       13,          $FF, $00, $00 
    byte   24,      0,        0,          $00, $00, $00 'End-of-dataset        